!---------------------------------------------------------------------------------
!  Main program to calculate the chi^2, more precisely the minimum of chi^2
!
!  The data is read in from the given file halo5.tab
!  The output has to written into a new file with the entries: M_200, c_200, chi^2
!---------------------------------------------------------------------------------
!--------------------------------------------------------------------------------------------------
!  ONE IMPORTANT NOTE: After you've modified the file 'subroutines.f90' you have to compile it once
!                      to get the programm running: 
!                      USE: ifort subroutines.f90
!--------------------------------------------------------------------------------------------------

program lenschi2
  ! We use some of the modules, defined in subroutines.f90 
  use cosmology
  use constants
  use profile
  use inputdata
  use chi2calc
  implicit none

  ! Defining the variables, you may add new ones of course or change the ones below
  double precision :: rs, dc, conc
  character(80) :: inputfile
  character(80) :: outputfile
  double precision :: rreal, creal, dreal, mreal, cmin, chicalc, mmin, chimin
  double precision :: rscan, cscan, dscan, mscan, xtheory, sheartheory
  integer :: i

  ! Defining the cosmological model -> flat LCDM 
  cosmopar%omegam = 0.27d0

  ! Some data for the lense
  ndat = 627656       ! # of datasets 
  zlens = 0.245d0     ! The redshift
  sigmashear = 0.3d0  ! The shearing

  dAlens = dA(zlens)
  rhoclens = rhocrit(zlens)
  
  ! Give the path to the input file and read it in
  inputfile = "../Data/halo5.tab"
  call readinput(inputfile)

  ! Opening the output file named 'chiscan.dat'
  open(unit=11, file="../Data/chiscan.dat", form="FORMATTED", status="UNKNOWN")
  
  ! Here comes your part...
  

  close(11)
  write(*,*) 'Minimum at Mass M200 = ',mmin 
  write(*,*) 'Minimum at concentration c200 = ',cmin 

end program lenschi2
